-- the callback function to executed by the button
function button_cb( control )

	print( "Button has been pressed", control );

end

-- Basically a button will always be added to the last window created. To change this you
-- can use luiSetParent to specify which window the control should be parented to. In
-- this case I'm going to set it as "main" so that the control is parented at the highest
-- level, ie the main frame.
--
luiSetParent("main");

-- this function call creates the button and returns the name of the new control as
-- a string.
luiButton {
	label 	= "Hello World!",	--	the text to be displayed on the control
	w 		= 100,				--	the width
	h 		= 25,				--	the height
	x 		= 5,				--	the x location
	y 		= 5,				--	the y position
	command	= "button_cb"		--	the command to be executed when the button is clicked
};

