aviViewer = {

	IMG=0,

	window=0,

	OpenFileCB = function( widget )

		-- get the filenames from the filedailog. Note that this dialog
		-- supports multiple files at the same time, this means that the function
		-- returns a table of files in an array.
		--
		local FileList ={};
		FileList = luiGetSelectedItems( widget ) ;

		-- Get the path to the file
		local Path = luiGetFilePath( widget );


		local FullFile = string.format("%s%s",Path,FileList[1]);

		local AviFileHandle = Avi.Open(FullFile,256,256);
		local iw= Avi.Width(AviFileHandle);
		local ih= Avi.Height(AviFileHandle);
		Avi.Play(AviFileHandle);

		luiSetInt(aviViewer.IMG,AviFileHandle);
		luiSetSize(aviViewer.IMG,iw,ih);
		luiSetSize(aviViewer.window,iw+4,ih+32);


	end,

	OnPlay = function( widget )

		local AviFileHandle = luiGetInt(aviViewer.IMG);
		Avi.Play(AviFileHandle);

	end,

	OnStop = function( widget )

		local AviFileHandle = luiGetInt(aviViewer.IMG);
		Avi.Stop(AviFileHandle);

	end,

	OnPause = function( widget )

		local AviFileHandle = luiGetInt(aviViewer.IMG);
		Avi.Pause(AviFileHandle);

	end,

	OnOpen = function()


		luiFileDialog {
			label = "avi file to view",
			name = "aviFileDialog",
			x = 420,
			y = 100,
			w = 250,
			h = 500,
			command="aviViewer.OpenFileCB"
		};

	end,

	OnCreate = function()

		aviViewer.window = luiWindow {
			label = "Avi Viewer",
			name = "aviViewerWindow",
			x = 50,
			y = 50,
			w = 100,
			h = 40,
			sz=0
		}

			luiIconButton {
				name = "OpenAviButton",
				w = 20,
				h = 20,
				x = 2,
				y = 2,
				icon = ICON_OPEN,
				command = "aviViewer.OnOpen"
			}

			luiArrowButton {
				name = "PlayAviButton",
				x = 22,
				y = 2,
				w = 20,
				h = 20,
				command = "aviViewer.OnPlay",
				dir = LUI_RIGHT
			}

			luiArrowButton {
				name = "StopAviButton",
				x = 44,
				y = 2,
				w = 20,
				h = 20,
				command = "aviViewer.OnStop",
				dir = LUI_STOP
			}

			luiArrowButton {
				name = "PauseAviButton",
				x = 66,
				y = 2,
				w = 20,
				h = 20,
				command = "aviViewer.OnPause",
				dir = LUI_PAUSE
			}

			aviViewer.IMG = luiAviView {
				name = "aviViewer",
				x = 2,
				y = 12
			}
	end
}

aviViewer.OnCreate();
