

imageViewer = {

	IMG=0,

	window=0,

	OpenFileCB = function( widget )

		-- get the filenames from the filedailog. Note that this dialog
		-- supports multiple files at the same time, this means that the function
		-- returns a table of files in an array.
		--
		local FileList ={};
		FileList = luiGetSelectedItems( widget ) ;

		-- Get the path to the file
		local Path = luiGetFilePath( widget );


		local FullFile = string.format("%s%s",Path,FileList[1]);

		local ImageFile = ImageLoad(FullFile)
		local iw=256;
		local ih=256;

		iw,ih = ImageGetSize(ImageFile);

		luiSetInt(imageViewer.IMG,ImageFile);
		luiSetSize(imageViewer.IMG,iw,ih);
		luiSetSize(imageViewer.window,iw+4,ih+32);

	end,

	OnOpen = function()


		luiFileDialog {
			label = "image file to view",
			name = "imageFileDialog",
			x = 420,
			y = 100,
			w = 250,
			h = 500,
			command="imageViewer.OpenFileCB"
		};

	end,

	OnCreate = function()

		imageViewer.window = luiWindow {
			label = "ImageViewer",
			name = "imageViewWindow",
			x = 50,
			y = 50,
			w = 100,
			h = 40
		}
			luiIconButton {
				name = "OpenImageButton",
				w = 20,
				h = 20,
				x = 2,
				y = 2,
				icon = ICON_OPEN,
				command = "imageViewer.OnOpen"
			}
			imageViewer.IMG = luiImageView {
				name = "imageview",
				x = 2,
				y = 12
			}
	end
}

imageViewer.OnCreate();