
--------------------------------------------------------------------------	String attributes
function DoStringCallback(ctrl,node,attr)
	local val = luiGetString(ctrl);
	Attr.Set( {node,attr}, val );
end

function MakeStringControl(x_,y_,w_,h_,nodeName,attrName)
	-- if node id, then get the name of the node instead
	if type(nodeName) == "number" then
		nodeName = Node.Name(nodeName);
	end

	-- make a name for the control
	local ctrl_name = string.format("%s_%s_edit",nodeName,attrName);

	-- make a new name for a new callback function
	local callback_name = string.format("%s_%s_callback",nodeName,attrName);

	-- create a callback function to register with the lua state
	local callback_str = string.format("function %s(widget)\nDoStringCallback(widget,\"%s\",\"%s\")",callback_name,nodeName,attrName);

	-- execute callback string so callback function is defined
	luiExecute(callback_str);

	luiIntField {
		w = w_,
		h = h_,
		x = x_,
		y = y_,
		name = ctrl_name,
		label = attrName,
		value = Attr.Get{nodeName,attrName},
		command = callback_name
	};

end

--------------------------------------------------------------------------	Integer attributes
function DoIntCallback(ctrl,node,attr)
	local val = luiGetInt(ctrl);
	Attr.Set( {node,attr}, val );
end

function MakeIntControl(x_,y_,w_,h_,nodeName,attrName)
	-- if node id, then get the name of the node instead
	if type(nodeName) == "number" then
		nodeName = Node.Name(nodeName);
	end

	-- make a name for the control
	local ctrl_name = string.format("%s_%s_edit",nodeName,attrName);

	-- make a new name for a new callback function
	local callback_name = string.format("%s_%s_callback",nodeName,attrName);

	-- create a callback function to register with the lua state
	local callback_str = string.format("function %s(widget)\nDoIntCallback(widget,\"%s\",\"%s\");\nend",callback_name,nodeName,attrName);

	print(callback_str);

	-- execute callback string so callback function is defined
	func = loadstring(callback_str);
	func();

	luiIntField {
		w = w_,
		h = h_,
		x = x_,
		y = y_,
		name = ctrl_name,
		label = attrName,
		value = Attr.Get{nodeName,attrName},
		command = callback_name
	};

end

--------------------------------------------------------------------------	Float attributes
function DoFloatCallback(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr}, val );
end

function MakeFloatControl(x_,y_,w_,h_,nodeName,attrName)
	-- if node id, then get the name of the node instead
	if type(nodeName) == "number" then
		nodeName = Node.Name(nodeName);
	end

	-- make a name for the control
	local ctrl_name = string.format("%s_%s_edit",nodeName,attrName);

	-- make a new name for a new callback function
	local callback_name = string.format("%s_%s_callback",nodeName,attrName);

	-- create a callback function to register with the lua state
	local callback_str = string.format("function %s(widget)\nDoFloatCallback(widget,\"%s\",\"%s\");\nend",callback_name,nodeName,attrName);

	print(callback_str);

	-- execute callback string so callback function is defined
	func = loadstring(callback_str);
	func();

	luiFloatField {
		w = w_,
		h = h_,
		x = x_,
		y = y_,
		name = ctrl_name,
		label = attrName,
		value = Attr.Get{nodeName,attrName},
		command = callback_name
	};
end





--------------------------------------------------------------------------	vector attributes
function DoFloatCallbackX(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"x"}, val );
end

function DoFloatCallbackY(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"y"}, val );
end

function DoFloatCallbackZ(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"z"}, val );
end

function MakeVectorControl(x_,y_,w_,h_,nodeName,attrName)
	-- if node id, then get the name of the node instead
	if type(nodeName) == "number" then
		nodeName = Node.Name(nodeName);
	end

	-- make a name for the control
	local ctrl_nameX = string.format("%s_%s_editX",nodeName,attrName);
	local ctrl_nameY = string.format("%s_%s_editY",nodeName,attrName);
	local ctrl_nameZ = string.format("%s_%s_editZ",nodeName,attrName);

	-- make a new name for a new callback function
	local callback_nameX = string.format("%s_%s_callbackX",nodeName,attrName);
	local callback_nameY = string.format("%s_%s_callbackY",nodeName,attrName);
	local callback_nameZ = string.format("%s_%s_callbackZ",nodeName,attrName);

	-- create a callback function to register with the lua state
	local callback_strX = string.format("function %s(widget)\nDoFloatCallbackX(widget,\"%s\",\"%s\");\nend",callback_nameX,nodeName,attrName);
	local callback_strY = string.format("function %s(widget)\nDoFloatCallbackY(widget,\"%s\",\"%s\");\nend",callback_nameY,nodeName,attrName);
	local callback_strZ = string.format("function %s(widget)\nDoFloatCallbackZ(widget,\"%s\",\"%s\");\nend",callback_nameZ,nodeName,attrName);

	-- execute callback string so callback function is defined
	func = loadstring(callback_strX);
	func();
	func = loadstring(callback_strY);
	func();
	func = loadstring(callback_strZ);
	func();

	lw = (w_-4)/3;
	px = x_;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameX,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"x"},
		command = callback_nameX
	};

	px = px+lw+2;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameY,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"y"},
		command = callback_nameY
	};

	px = px+lw+2;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameZ,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"z"},
		command = callback_nameZ
	};
end




--------------------------------------------------------------------------	colour attributes
function DoFloatCallbackR_(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"r"}, val );
end

function DoFloatCallbackG_(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"g"}, val );
end

function DoFloatCallbackB_(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"b"}, val );
end

function MakeColorControl(x_,y_,w_,h_,nodeName,attrName)
	-- if node id, then get the name of the node instead
	if type(nodeName) == "number" then
		nodeName = Node.Name(nodeName);
	end

	-- make a name for the control
	local ctrl_nameR = string.format("%s_%s_editR",nodeName,attrName);
	local ctrl_nameG = string.format("%s_%s_editG",nodeName,attrName);
	local ctrl_nameB = string.format("%s_%s_editB",nodeName,attrName);

	-- make a new name for a new callback function
	local callback_nameR = string.format("%s_%s_callbackR",nodeName,attrName);
	local callback_nameG = string.format("%s_%s_callbackG",nodeName,attrName);
	local callback_nameB = string.format("%s_%s_callbackB",nodeName,attrName);

	-- create a callback function to register with the lua state
	local callback_strR = string.format("function %s(widget)\nDoFloatCallbackR_(widget,\"%s\",\"%s\");\nend",callback_nameR,nodeName,attrName);
	local callback_strG = string.format("function %s(widget)\nDoFloatCallbackG_(widget,\"%s\",\"%s\");\nend",callback_nameG,nodeName,attrName);
	local callback_strB = string.format("function %s(widget)\nDoFloatCallbackB_(widget,\"%s\",\"%s\");\nend",callback_nameB,nodeName,attrName);

	-- execute callback string so callback function is defined
	func = loadstring(callback_strR);
	func();
	func = loadstring(callback_strG);
	func();
	func = loadstring(callback_strB);
	func();

	lw = (w_-4)/3;
	px = x_;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameR,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"r"},
		command = callback_nameR
	};

	px = px+lw+2;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameG,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"g"},
		command = callback_nameG
	};

	px = px+lw+2;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameB,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"b"},
		command = callback_nameB
	};
end




--------------------------------------------------------------------------	plane attributes
function DoFloatCallbackA(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"a"}, val );
end

function DoFloatCallbackB(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"b"}, val );
end

function DoFloatCallbackC(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"c"}, val );
end

function DoFloatCallbackD(ctrl,node,attr)
	local val = luiGetFloat(ctrl);
	Attr.Set( {node,attr,"d"}, val );
end

function MakePlaneControl(x_,y_,w_,h_,nodeName,attrName)
	-- if node id, then get the name of the node instead
	if type(nodeName) == "number" then
		nodeName = Node.Name(nodeName);
	end

	-- make a name for the control
	local ctrl_nameA = string.format("%s_%s_editA",nodeName,attrName);
	local ctrl_nameB = string.format("%s_%s_editB",nodeName,attrName);
	local ctrl_nameC = string.format("%s_%s_editC",nodeName,attrName);
	local ctrl_nameD = string.format("%s_%s_editD",nodeName,attrName);

	-- make a new name for a new callback function
	local callback_nameA = string.format("%s_%s_callbackA",nodeName,attrName);
	local callback_nameB = string.format("%s_%s_callbackB",nodeName,attrName);
	local callback_nameC = string.format("%s_%s_callbackC",nodeName,attrName);
	local callback_nameD = string.format("%s_%s_callbackD",nodeName,attrName);

	-- create a callback function to register with the lua state
	local callback_strA = string.format("function %s(widget)\nDoFloatCallbackA(widget,\"%s\",\"%s\");\nend",callback_nameA,nodeName,attrName);
	local callback_strB = string.format("function %s(widget)\nDoFloatCallbackB(widget,\"%s\",\"%s\");\nend",callback_nameB,nodeName,attrName);
	local callback_strC = string.format("function %s(widget)\nDoFloatCallbackC(widget,\"%s\",\"%s\");\nend",callback_nameC,nodeName,attrName);
	local callback_strD = string.format("function %s(widget)\nDoFloatCallbackD(widget,\"%s\",\"%s\");\nend",callback_nameD,nodeName,attrName);

	-- execute callback string so callback function is defined
	func = loadstring(callback_strA);
	func();
	func = loadstring(callback_strB);
	func();
	func = loadstring(callback_strC);
	func();
	func = loadstring(callback_strD);
	func();

	lw = (w_-6)/4;
	px = x_;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameA,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"a"},
		command = callback_nameA
	};

	px = px+lw+2;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameB,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"b"},
		command = callback_nameB
	};

	px = px+lw+2;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameC,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"c"},
		command = callback_nameC
	};

	px = px+lw+2;

	luiFloatField {
		w = lw,
		h = h_,
		x = px,
		y = y_,
		name = ctrl_nameD,
		label = attrName,
		value = Attr.Get{nodeName,attrName,"d"},
		command = callback_nameD
	};
end











function MakeAttributeEditor(nodeName)
	luiWindow {
		name = "AttrEd",
		label = "Attribute Editor",
		x = 100,
		y = 100,
		w = 400,
		h = 600
	};

		luiFrameLayout {
			label = "Common Attributes",
			x=2,
			y=2,
			w=396,
			h=100
		};
			luiText {
				label = "name",
				x=5,
				y=20,
				w=30,
				name = "AttrEdName"
			};
			luiText {
				label = nodeName,
				x=35,
				y=20,
				w=300,
				name = "AttrEdName"
			};
		luiSetParent("..");

		luiFrameLayout {
			label = "Other Attributes",
			x=2,
			y=102,
			w=396,
			h=500
		};
			local y = 20;
			attrlist = Attr.List(nodeName);
			for i=1,table.getn(attrlist) do
				print(attrlist[i]);
				local type = Attr.Type{ nodeName, attrlist[i] };

				luiText {
					label = attrlist[i],
					x=5,
					y=y,
					w=90,
					name = string.format("label_%s_%s",nodeName,attrlist[i]);
				};

				if type == "bool" then

				elseif type == "char" then
					MakeIntControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
				elseif type == "short" then
					MakeIntControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
				elseif type == "int" then
					MakeIntControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
				elseif type == "long" then
					MakeIntControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
				elseif type == "float" then
					MakeFloatControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
				elseif type == "double" then
					MakeFloatControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
				elseif type == "XVector" then
					MakeVectorControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
					print("vector");
				elseif type == "XColour" then
					MakeColorControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
				elseif type == "XPlane" then
					MakePlaneControl(100,y,280,20,nodeName,attrlist[i]);
					y = y+22;
				elseif type == "string" then
					y = y+22;

				end
			end

		-- back to attr editor window
		luiSetParent("..");

	-- back to main window
	luiSetParent("..");

end




luiDestroy("Outliner");

function OutlinerGenAttr(widget)
	local NewList = luiGetSelectedItems( widget );

	if table.getn(NewList)>=1 then
		luiDestroy("AttrEd");
		MakeAttributeEditor(NewList[1]);
	end
end

luiWindow {
	name = "Outliner",
	label = "Outliner",
	x = 200,
	y = 100,
	w = 250,
	h = 400
};
	local nodes = Node.List();
	luiListBox {
		name = "OutlinerListBox",
		w = 240,
		h = 370,
		x = 5,
		y = 5,
		items = nodes,
		command = "OutlinerGenAttr"
	};

	luiSetParent("..");










