

-------------------------------------------
-- I seemed to have developed this odd idea of subclassing
-- for no particular reason in tables. Kinda shat OOP,
--
winamp = {

	volume = 1,

	WindowOpen=0,

	----------------------------------------
	-- The List box control
	ListBox="",

	----------------------------------------
	-- the tracklist for the mp3's
	PlayList = {},


	----------------------------------------
	-- the current track being played
	CurrentTrack=0,


	----------------------------------------
	-- Is playback paused?
	IsPaused=0,

	----------------------------------------
	-- This function is the destroy callback
	--
	OnDestroy = function()
		winamp.WindowOpen = 0;
		winamp.IsPaused = 0;
		Mp3.Stop();
	end,

	----------------------------------------
	-- This creates the MP3Player window
	OnCreate = function()

		-- only going to allow
	--	if winamp.WindowOpen == 0 then

			luiWindow {
				od = "winamp.OnDestroy",
				label = "winamp",
				h = 200,
				w = 224,
				sz = 0
			}

			luiIconButton {
				x = 5,
				y = 5,
				w = 25,
				h = 25,
				name= "Open",
				command = "winamp.OnOpenFile",
				icon = ICON_OPEN
			}

			luiButton {
				l = "Add",
				x = 32,
				y = 5,
				w = 25,
				h = 25,
				command = "winamp.OnAddFile"
			}

			luiIconButton {
				x = 59,
				y = 5,
				w = 25,
				h = 25,
				command = "winamp.OnSaveFile",
				icon = ICON_SAVE
			}

			luiArrowButton {
				x = 86,
				y = 5,
				w = 25,
				h = 25,
				command = "winamp.OnPrevTrack",
				dir = LUI_FAST_LEFT
			}

			luiArrowButton {
				x = 113,
				y = 5,
				w = 25,
				h = 25,
				command = "winamp.OnPressPlay",
				dir = LUI_RIGHT
			}

			luiArrowButton {
				x = 140,
				y = 5,
				w = 25,
				h = 25,
				command = "winamp.OnNextTrack",
				dir = LUI_FAST_RIGHT
			}

			luiArrowButton {
				x = 167,
				y = 5,
				w = 25,
				h = 25,
				command = "winamp.OnStop",
				dir = LUI_STOP
			}

			luiArrowButton {
				x = 194,
				y = 5,
				w = 25,
				h = 25,
				command = "winamp.OnPause",
				dir = LUI_PAUSE
			}

			luiText {
				label = "volume",
				x = 5,
				y = 32,
				w = 50,
				h = 25
			}

			luiFloatSlider {
				x = 60,
				y = 32,
				w = 159,
				h = 25,
				command = "winamp.OnVolumeChanged"
			}

			winamp.ListBox = luiListBox {
				x = 5,
				y = 59,
				w = 214,
				h = 120,
				en = 0	-- cant be bothered to sort selection yet
			}
		--end
	end,


	----------------------------------------
	-- The callback for the open file button
	OnAddFileDialog = function( dialog )

		-- get the new playlist
		local NewList = luiGetSelectedItems( dialog ) ;

		-- this will hold the expanded files
		local SortedList = luiGetItems( winamp.ListBox ) ;

		-- the path to the file
		local Path = luiGetFilePath( dialog );

		-- now then, can't just wang all files into the playlist,
		-- we may have one or two *.m3u files in their also. If
		-- thats the case then load the m3u files and add them all
		-- into the playlist.
		--
		for file in NewList do

			-- if the last 4 chars are .m3u then load a playlist
			if string.sub(NewList[file],-4) == ".m3u" then

				-- read the m3u file
				local FromM3u = winamp.ReadM3uFile( string.format("%s%s",Path,NewList[file]) );

				-- loop through returned entries and add them into the playlist
				for m3ufile in FromM3u do
					table.insert( SortedList, FromM3u[m3ufile] );
					table.insert( winamp.PlayList, string.format("%s%s", Path, FromM3u[m3ufile]) );
				end
			else
				-- just insert the single filename
				table.insert( SortedList, NewList[file] );
				table.insert( winamp.PlayList, string.format("%s%s", Path, NewList[file]) );
			end
		end

		-- set the items in the listbox
		luiSetItems( winamp.ListBox, SortedList );

		if not Mp3IsPlaying() then
			-- start playback from the beginning of the playlist
			winamp.CurrentTrack = 1;
			Mp3.Play( winamp.PlayList[ winamp.CurrentTrack ] );
			Mp3.Volume( winamp.volume );
		end

	end,

	----------------------------------------
	-- The callback for the open file button
	OnOpenFileDialog = function( dialog )

		-- get the new playlist
		local NewList = luiGetSelectedItems( dialog ) ;

		-- this will hold the expanded files
		local SortedList = {}

		-- the path to the file
		local Path = luiGetFilePath( dialog );

		-- set the original playlist to have zero elements
		table.setn( winamp.PlayList, 0 );

		-- stop playback just in case
		Mp3.Stop();

		-- now then, can't just wang all files into the playlist,
		-- we may have one or two *.m3u files in their also. If
		-- thats the case then load the m3u files and add them all
		-- into the playlist.
		--
		for file in NewList do

			-- if the last 4 chars are .m3u then load a playlist
			if string.sub(NewList[file],-4) == ".m3u" then

				-- read the m3u file
				local FromM3u = winamp.ReadM3uFile( string.format("%s%s",Path,NewList[file]) );

				-- loop through returned entries and add them into the playlist
				for m3ufile in FromM3u do
					table.insert( SortedList, FromM3u[m3ufile] );
					table.insert( winamp.PlayList, string.format("%s%s", Path, FromM3u[m3ufile]) );
				end
			else
				-- just insert the single filename
				table.insert( SortedList, NewList[file] );
				table.insert( winamp.PlayList, string.format("%s%s", Path, NewList[file]) );
			end
		end

		-- set the items in the listbox
		luiSetItems( winamp.ListBox, SortedList );

		-- start playback from the beginning of the playlist
		winamp.CurrentTrack = 1;
		Mp3.Play( winamp.PlayList[ winamp.CurrentTrack ] );
		Mp3.Volume( winamp.volume );
	end,



	----------------------------------------
	-- The next track button callback function
	OnNextTrack = function ( name )

		-- move to next track
		winamp.CurrentTrack = winamp.CurrentTrack+1;

		-- how big is the playlist?
		num = table.getn( winamp.PlayList );

		-- make sure not hit end of playlist
		if winamp.CurrentTrack > num then
			winamp.CurrentTrack = 0;
		end

		-- play the next MP3
		Mp3.Play( winamp.PlayList[ winamp.CurrentTrack ] );
		Mp3.Volume( winamp.volume );
	end,


	----------------------------------------
	-- The next track button callback function
	OnPrevTrack = function( name )

		winamp.CurrentTrack = winamp.CurrentTrack-1;
		if winamp.CurrentTrack ~= 0 then
			Mp3.Play( winamp.PlayList[ winamp.CurrentTrack ] );
			Mp3.Volume( winamp.volume );
		end
	end,

	----------------------------------------
	-- This function stops playback of the file
	OnStop = function( name )
		Mp3.Stop();
		winamp.CurrentTrack = 0;
	end,

	----------------------------------------
	-- This function stops playback of the file
	OnPause = function( name )
		if winamp.IsPaused == 0 then
			Mp3.Pause(1);
			winamp.IsPaused = 1;
		else
			Mp3.Pause(0);
			winamp.IsPaused = 0;
		end
	end,


	----------------------------------------
	-- This function creates an openFile dialog whenever
	-- play is pressed,
	OnOpenFile = function( name )
		luiFileDialog {
			name = "open file",
			x = 420,
			y = 100,
			w = 250,
			h = 500,
			command = "winamp.OnOpenFileDialog"
		}
	end,

	----------------------------------------
	-- This function creates an openFile dialog whenever
	-- play is pressed,
	OnAddFile = function( name )
		luiFileDialog {
			name = "open file",
			x = 420,
			y = 100,
			w = 250,
			h = 500,
			command = "winamp.OnAddFileDialog"
		}
	end,

	----------------------------------------
	-- This function creates an openFile dialog whenever
	-- play is pressed,
	OnPressPlay = function( name )

		-- If no tracks are currently loaded
		if table.getn( winamp.PlayList ) == 0 then
			return;
		end

		-- If the current rack is invalid, set it to the first track
		if winamp.CurrentTrack == 0 then
			winamp.CurrentTrack = 1;
		end

		-- play the MP3
		Mp3.Play( winamp.PlayList[ winamp.CurrentTrack ] );
		Mp3.Volume( winamp.volume );
	end,


	----------------------------------------
	-- This function is called when the user changes the volume
	--
	OnVolumeChanged = function( name )
		winamp.volume = luiGetFloat( name );
		Mp3.Volume( winamp.volume );

	end,

	----------------------------------------
	-- This function reads an m3u file and
	-- returns an array of all files referenced
	-- by it.
	ReadM3uFile = function( filename )

		-- the table we will fill with strings
		local ReturnStuff = {};

		-- read each line in the file
		for line in io.lines(filename) do

			-- use the string.byte function to query the ascii
			-- value of the last char
			local lastchar = string.byte(line,-1);

			-- if the value is 13 then we have a carriage return
			if lastchar == 13 then
				-- insert the stripped string at the end of the table
				table.insert( ReturnStuff, string.sub(line,1,-2) );

			else
				-- insert the string at the end of the table
				table.insert( ReturnStuff, line );

			end
		end

		-- return the table
		return ReturnStuff;

	end

};

winamp.OnCreate();







