

EdColour = {

	OnColorChangeR = function(col,widget)
		local r;
		local g;
		local b;
		r,g,b = luiGetColor(col);
		r = luiGetFloat(widget);
		luiSetColor( col, r, g, b );
	end,

	OnColorChangeG = function(col,widget)
		local r;
		local g;
		local b;
		r,g,b = luiGetColor(col);
		g = luiGetFloat(widget);
		luiSetColor( col, r, g, b );
	end,

	OnColorChangeB = function(col,widget)
		local r;
		local g;
		local b;
		r,g,b = luiGetColor(col);
		b = luiGetFloat(widget);
		luiSetColor( col, r, g, b );
	end

};

function MakeColStrings(col)
	local func;
	local fname0,fname1,fname2;
	fname0 = string.format("OnRedChanged%d",col);
	func = string.format("function %s(widget)\nEdColour.OnColorChangeR(%d,widget)\nend",fname0,col);
	func = loadstring(func);
	func();

	fname1 = string.format("OnGreenChanged%d",col);
	func = string.format("function %s(widget)\nEdColour.OnColorChangeG(%d,widget)\nend",fname1,col)
	func = loadstring(func);
	func();

	fname2 = string.format("OnBlueChanged%d",col);
	func = string.format("function %s(widget)\nEdColour.OnColorChangeB(%d,widget)\nend",fname2,col)
	func = loadstring(func);
	func();
	return fname0,fname1,fname2;
end

function MakeColourControl( col_id, name, x_, y_, w_, h_ )
	local r_,g_,b_,grp;

	r_,g_,b_ = luiGetColor(col_id);

	grp = luiGroup {
		x=x_,
		y=y_,
		w=w_,
		h=h_
	};
		local space = (w_-56)/4;
		luiText {
			w = space+46,
			h = h_-4,
			x = 4,
			y = 2,
			label=name
		};

		fname0,fname1,fname2 = MakeColStrings(col_id);

		luiFloatField {
			value = r_,
			x = space+52,
			w = space,
			h = h_-6,
			y = 2,
			command = fname0
		};

		luiFloatField {
			value = g_,
			x = 2*space+54,
			y = 2,
			w = space,
			h = h_-6,
			command = fname1
		};

		luiFloatField {
			value = b_,
			x = 3*space+56,
			y = 2,
			w = space,
			h = h_-6,
			command = fname2
		};

	luiSetParent("..");

	return grp;
end

	local y_=2;
	local x_=4;
	local inc=25;
	local pinc=4;
	local totinc=inc+pinc ;

luiWindow {
	label = "User Interface Colours",
	w = 358,
	h = totinc*13+20
}

	MakeColourControl( LUI_COLOR_3D_OBJECTS,"3D Objects", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_BLACK, 	"Black", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_TITLE1, 	"Title 1", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_TITLE2, 	"Title 2", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_TITLE_TEXT,"Title Text", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_WINDOW, 	"Window", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_WINDOW_TEXT,"Window Text", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_MENU, 		"Menu", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_MENU_TEXT, "Menu Text", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_HIGHLIGHT, "Highlight", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_DARK_GREY,	"Dark Grey", x_, y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_GREY, "Grey", x_ ,y_, 350,inc );
	y_ = y_ + totinc;
	MakeColourControl( LUI_COLOR_LIGHT_GREY,"Light Grey", x_, y_, 350,inc );
	y_ = y_ + totinc;

luiSetParent("..");

function SaveScheme(name)

	FP = io.open( string.format( "startmenu/colour schemes/%s.lua",name) , "w" );
	for i=LUI_COLOR_3D_OBJECTS,LUI_COLOR_LIGHT_GREY do

		local r_,g_,b_;
		r_,g_,b_ = luiGetColor(i);
		FP:write( string.format( "luiSetColor(%d,%f,%f,%f)\n",i,r_,g_,b_) );

	end

	io.close(FP);

end
